;=====================================================================
;                       PCTOOLS 98 PLUGINS SDK
;                (c) Benoit SCHERRER, NeXO Software
;
;---------------------------------------------------------------------
; PLUGINS SDK VERSION   : 1.00
; FILE DESCRIPTION      : Change APD Plugin
;=====================================================================

	include "tios.h"                ;library includes files
	include "flib.h"
	include "api92.h"

	xdef    _main                   ;normal assembly program
	xdef    _comment

	include "pctplug.h"             ;and after we include pctplug.h


;--------------------------------------------------------------------
; Start of PCTOOLS 98 plugin
;--------------------------------------------------------------------

	PRG_AS_PLUGIN

sp_ext  dc.b    NOT_USED                ;specific extension ?
export  dc.b    %0000100               ;export flag byte

	dc.l    NOT_USED         	;1:Initialization of PCT98
	dc.l    NOT_USED                ;2:End of PCT98
	dc.l    KeyPressed              ;3:Key pressed
	dc.l    NOT_USED                ;4:ENTER pressed
	dc.l    NOT_USED             	;5:Cursor moved
	dc.l    NOT_USED                ;6:Show Item

END_PLUGIN_TABLE:

StartPrgm:
	lea	APDWin(PC),a0			;Draw nice Window
	jsr	api92::DrawWindow

	moveq.w	#0,d0				;Set small font
	jsr	api92::SetFont

	lea	info(PC),a0			;draw information
	jsr	api92::DrawString

	moveq.w	#1,d0				;Set medium font
	jsr	api92::SetFont

	move.l	APD_INIT,d4			;current value of APD

Loop	move.l	d4,d0				;Convert APD value to string
	moveq.w	#7,d1				;8 digit-1
	suba.w	#10,a7				;create 10 bytes stack frame
	move.l	a7,a0
	jsr	api92::HexaToStr

	moveq.w	#95,d0				;Draw APD value to screen
	moveq.w	#60,d1
	move.l	a0,a1
	jsr	api92::DrawStringSpecial

	adda.w	#10,a7				;delete stack frame
	
	jsr	flib::idle_loop			;wait for a key...
						;Here It should be a very small
						;way to see which key was pressed

	moveq.w	#7,d1				;8 loops -1 for dbra
	lea	KeyCodes(PC),a0			;addresses of arrays
	lea	Offsets(PC),a1

\scan	cmp.w	(a0)+,d0
	bne.s	\nokey
	add.w	(a1),d4
\nokey	addq.l	#2,a1
	dbra.s	d1,\scan	

	cmp.w	#264,d0
	beq.s	\esc
	cmp.w	#13,d0
	bne.s	Loop

	move.l	d4,APD_INIT

\esc	rts

;---------------------------------------------------------------------
; Function called when a key is pressed in PCT98
;
; Notice that this function will be execute only if PCT98
; itself doesn't already use this keycode.
;
; USE SPECIFIC EXTENSION
;
;Input> rg1.w : Value of keycode
;       rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;       rg3.l : Address of the current VAT list buffer
;Out>
;
;RETURN> REDRAW_SCREEN : request to redraw the screen
;	 SHOW_MESSAGE : request to print a message in the
;	  status bar. The message is pointed by rg2 and must
;	  be valid
;---------------------------------------------------------------------
KeyPressed:
	cmp.w	#8257,rg1+2	;<> A
	beq.s	\validkey
	rtplugin 0

\validkey
	bsr	StartPrgm
  	rtplugin REDRAW_SCREEN


;====================================================================
; Plugin Data
;====================================================================
APDWin:
		dc.b	60,50,180,76
chgApd		dc.b	"Change APD",0

info		dc.b	80,70,"(ESC:Cancel   ENTER:OK)",0

			;Pad, 	2nd+Pad,   Diam+Pad,  Maj+Pad
KeyCodes	dc.w	338,344,4434,4440,8530,8536,16722,16728
Offsets		dc.w	1,$FFFF,$10,$FFF0,$100,$FF00,$1000,$F000

_comment
	dc.b    "APD PCT98 Plugin",0

	end
