;=====================================================================
;                       PCTOOLS 98 PLUGINS SDK
;                (c) Benoit SCHERRER, NeXO Software
;
;---------------------------------------------------------------------
; PLUGINS SDK VERSION   : 1.00
; FILE DESCRIPTION      : Typical Plugin Program 
;=====================================================================

	include "tios.h"                ;library includes files
	include "flib.h"

	xdef    _main                   ;normal assembly program
	xdef    _comment

	include "pctplug.h"             ;We must include pctplug.h before
					;any other assembly code

;--------------------------------------------------------------------
; Start of PCTOOLS 98 plugin
;--------------------------------------------------------------------
	PRG_AS_PLUGIN

sp_ext  dc.b    NOT_USED                ;specific extension ?
export  dc.b    %00000000               ;export flag byte

	dc.l    NOT_USED                ;1:Initialization of PCT98
	dc.l    NOT_USED                ;2:End of PCT98
	dc.l    NOT_USED                ;3:Key pressed
	dc.l    NOT_USED                ;4:ENTER pressed
	dc.l    NOT_USED                ;5:Cursor moved
	dc.l    NOT_USED                ;6:Show Item

END_PLUGIN_TABLE:
	;(...)                          the program can continue
	rts


;---------------------------------------------------------------------
; Function called when PCTOOLS 98 is initializing.
;
;Input> 
;Out>  
;
;RETURN> SKIP_PCTPROCESS : request end of pct98
;---------------------------------------------------------------------
;InitializePCT98:
;
;       rtplugin 0


;---------------------------------------------------------------------
; Function called when PCTOOLS 98 is exiting.
;
;Input> 
;Out>
;
;RETURN> SKIP_PCTPROCESS : request NO end of PCT98
;---------------------------------------------------------------------
;EndPCT98:
;
;       rtplugin 0

;---------------------------------------------------------------------
; Function called when a key is pressed in PCT98
;
; Notice that this function will be execute only if PCT98
; itself doesn't already use this keycode.
;
; USE SPECIFIC EXTENSION
;
;Input> rg1.w : Value of keycode
;       rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;       rg3.l : Address of the current VAT list buffer
;Out>
;
;RETURN> REDRAW_SCREEN : request to redraw the screen
;	 SHOW_MESSAGE : request to print a message in the
;	  status bar. The message is pointed by rg2 and must
;	  be valid
;---------------------------------------------------------------------
;KeyPressed:
;
;       rtplugin 0


;---------------------------------------------------------------------
; Function called when ENTER is pressed on a File/Folder,
; before PCT98 uses it 
;
; USE SPECIFIC EXTENSION
;
;Input>	rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;Out>
;
;RETURN> REDRAW_SCREEN : request to redraw the screen
;	 SHOW_MESSAGE : request to print a message in the
;	  status bar. The message is pointed by rg2 and must
;	  be valid
;	 SKIP_PCTPROCESS : request that PCT98 don't run its
;	  KeyEnter subroutine
;---------------------------------------------------------------------
;KeyEnter:
;
;       rtplugin 0


;---------------------------------------------------------------------
; Function called when the cursor is moved to a new item
;
; USE SPECIFIC EXTENSION
;
;Input>	rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;Out>
;
;RETURN> SHOW_MESSAGE : request to print a message in the
;	  status bar. The message is pointed by rg2 and must
;	  be valid
;	 SKIP_PCTPROCESS : request that PCT98 don't print something
;	  in the status bar
;---------------------------------------------------------------------
;CursorMoved:
;
;       rtplugin 0


;---------------------------------------------------------------------
; Function called when PCT98 show items on the screen
;
; USE SPECIFIC EXTENSION
;
;Input> rg1.w : Y screen position of item
;	rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;Out>
;
;RETURN> SKIP_PCTPROCESS : request that PCT98 don't run its
;	  ShowItem subroutine
;---------------------------------------------------------------------
;ShowItem:
;
;       rtplugin 0



;====================================================================
; Plugin Data
;====================================================================


_comment
	dc.b    "PCTOOLS 98 Plugin",0

	end

